/* par_sym.h */

#ifndef SYM_H
#define SYM_H

#include "par_stack.h"

typedef struct sym_t
{
  char *name;			/* Token name. */
  int type;			/* Type code. */
  char *flex_def;		/* Flex def for mvt's. */
  int reserved;			/* Reserved word indicator. */
} SYM;


SYM *sym_add_symbol_sorted (STACK * stack, char *name);
SYM *sym_find_symbol (STACK * stack, char *name);
SYM *sym_set_type_by_name (STACK * stack, char *name, int type);

void sym_set_type (SYM * sym, int type);
int  sym_isres (STACK * stack, char *name);
void sym_rwtbl (STACK * stack, FILE * fd);
void sym_pr_symtbl (STACK * stack);
void sym_add_flexdef (STACK * stack, char *name, char *flex_def);
void sym_pr_rwtbl_def_to_file (STACK * stack, FILE * fd);
void sym_pr_rwtbl_to_file (STACK * stack, FILE * fd);
int sym_set_table_codes (STACK * stack, int code);

#endif
