/* dan_act.h */

#ifndef ACT_H
#define ACT_H

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#define RTN_ONE 11
#define RTN_ZERO 10
#define RTN_ELSE 12
#define RTN_ERR  13

#define OP_UNARY  0
#define OP_BINARY 1

typedef struct link_t
{
    struct link_t *next;
    char   *sym;
} LINK;


typedef struct node_t 
{
    struct node_t *rlink; /* Link to next rule. */
    struct node_t *nlink; /* Link to next node in a rule. */
    struct node_t *alt;   /* Alternative (false) node. */
    struct node_t *suc;   /* Successor (true) node. */
    char   *name;         /* Name of  token.*/ 
    LINK   *action[1];    /* List of actions from bstrings. */
    LINK   *code_ref[1];  /* List of actions from code refs. */
    LINK   *fun_ref[1];   /* List of actions from function refs. */
    void   *sym;          /* Symbol table entry for token. */
    int    type;          /* Node type. */
    int    id;            /* Node id. */
    int    ano;           /* Action number. */
    int    lno;           /* Label number. */
    int    eno;           /* Error number. */
}NODE;


#endif

