/* par_.h */
/* DANTE STUB DO NOT EDIT REQUIRED PART. */
/* MAY BE ADDED TO. */
#ifndef PAR__H
#define PAR__H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "dan_act.h"

typedef struct
{
  char   *symbol;      /* Symbol being assemb. by lexer.*/
  FILE   *fd;          /* Current input file.*/
  void   *act;         /* Pointer to action routine structure.*/
  char   *buffer;       /* buffer for input. */
  double d_value;       /* Return from action routine. */
  char   *s_value;      /* Return from action routine. */
  long   l_value;       /* Return from action routine. */
  int    i_value;       /* Return from action routine. */
  int    sindex;        /* Index into symbol being assembled. */
  int    slimit;        /* Limit of sumbol. */
  int    type;          /* Type returned by lexer. */
  int    req_type;
  int    lex_type;
  int    match;         /* CMP match.*/
  int    lineno;        /* Current line number. */
  int    buf_pos;       /* Char position in input buffer. */
  int    buf_len;       /* Length of data in input buffer. */
  int    error_flag;    /* Set if an error is detected. */
  int    buffer_input;  /* Flag for buffer input. */
  int    print_input;
  int    print_lexout;

 /* Lexer support. */
  int lex_c; /* Lex value. */
  int lex_t; /* Lex type.  */
  int lex_m; /* lex match. */
  /* End of generic par.h */

  /* End of generic par.h */
  /* Dante specific flags.*/

  char   *pname;       /* Name of network node - used in proc names.*/
  char   *lname;       /* Name of lexer usualy pname.*/
  void   *top_rule;    /* Rule list. */
  NODE   *last_rule;   /* Last rule on list. */
  NODE   *last_node;   /* Last node allocated. */
  void   *stk_oper;    /* Operator stack. */
  void   *stk_opnd;    /* Operand stack. */
  void   *stk_literal; /* Literal List */
  void   *rwtbl;       /* reserved word table. */
  void   *littbl;      /* Literal table. */
  void   *opertbl;    /* Operator table. */
  char   *sym_name;   /* A temp. holder for sym_name for dan_type. */
  char   *flex_name;  /* A temp. holder for flex_name for flex def. */

  int gen_flex;   /* Dante flag. */
  int gen_code;   /* Dante flag. */
  int gen_intp;   /* Dante flag. */
  int gen_lexer;  /* Dante flag. */
  int gen_buf_in; /* Dante flag. */
  int sub_of;     /* Dante flag. */
  int no_support; /* Dante flag. */
  int cnf;        /* Dante flag. */
  int use_flex;   /* Dante flag. */ 

  /* Command line options.*/
  int opt_verbose;  /* Dante flag. */
  int opt_net_file; /* Dante flag. */
  int opt_html;     /* Dante flag. */
  int opt_default_lexer;       /* Dante flag. */
  int opt_print_input;         /* Dante flag. */
  int opt_print_lexer_output;  /* Dante flag. */
  int opt_use_switch;          /* Dante flag. */

} PAR; 
#endif  
