/* par_gen_flex.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
#include <stdio.h>
#include <string.h>
#include "par.h"
#include "dan_act.h"
#include "par_sym.h"
/* ----------------------------------------------------------------- */
static char *str1 = "  printf (\"LEXERR: %s lineno %d line %s\",err,lineno,yytext);";
static char *str3 = "%}";
static char *str5 = "%{";
static char *str6 = "ws        [ \\t\\0]+\n";
static char *double_percent = "%%";
/* ----------------------------------------------------------------- */
void
par_gen_flex (PAR *par)
{
  FILE *fd;
  SYM *sym;
  int  k;
  char *name;
  char *pname;
  char filename [48];

  pname = par->pname;
  strcpy (filename, pname);
  strcat (filename, "_flex.l");
  
  fd = fopen (filename, "w");
  if (!fd)
    {
      fprintf (stderr, "ERROR:PAR_GEN_FLEX:Could not open file for flex code.\n");
      exit (1);
    }
  fprintf (fd, "/* lexer.l */\n");
  fprintf (fd, "\n");

  fprintf (fd, "%s\n", str5);
  fprintf (fd, "#include \"par_%s_types.h\"\n", pname);
  fprintf (fd, "#include <stdlib.h>\n");
  fprintf (fd, "#include <string.h>\n");
  fprintf (fd, "\n");

  fprintf (fd, "extern int lineno;\n");
  fprintf (fd, "%s\n", str3);
  fprintf (fd, "%s", str6);
  fprintf (fd, "\n\n");
  fprintf (fd, "comment #.*\n\n");
  fprintf (fd, "nl     \\n\n\n");
  k = 0;
  while (sym = (SYM *)Item(par->rwtbl, k++))
    if (sym->flex_def)
	fprintf (fd, "%s\t%s\n", sym->name, sym->flex_def);
     
  fprintf (fd, "\n");
  /* Rule section. */
  fprintf (fd, "%s\n", double_percent);
  fprintf (fd, "\n\n");
  fprintf (fd, "{nl}          { lineno++; } \n");
  fprintf (fd, "{ws}          ;\n\n");
 

  /* All keywords are on the rwtbl. */
  k = 0;
  while (sym = (SYM *)Item(par->rwtbl, k++))
    {
      name = sym->name;
      if (sym->flex_def == 0)
	fprintf (fd, "%s  { return TYPE_%s; } \n", name, name);
    }
   k = 0;
  while (sym = (SYM *)Item(par->rwtbl, k++))   
    if (sym->flex_def)
      fprintf (fd, "{%s}  { return TYPE_%s; }\n", sym->name, sym->name);

fprintf (fd, "\n");
fprintf (fd, "%s\n", double_percent);
fprintf (fd, "#include <stdio.h>\n");
fprintf (fd, "#include \"par.h\"\n");
fprintf (fd, "int lineno = 0;\n");
fprintf (fd, "void yyerror (char *err)\n");
fprintf (fd, "{\n");
fprintf (fd, "%s\n", str1);
fprintf (fd, "}\n");

fprintf (fd, "int yywrap ()\n");
fprintf (fd, "{\n");
fprintf (fd, "return 1;\n");
fprintf (fd, "}\n");


fprintf (fd, "int par_%s_lex (PAR *par)\n", pname);
fprintf (fd, "{\n");
fprintf (fd, "yyin = par->fd;\n");
fprintf (fd, "par->type = yylex();\n");
fprintf (fd, "strcpy (par->symbol, yytext);\n");

fprintf (fd, "return par->type;\n");
fprintf (fd, "}\n");
fclose (fd);
}
