/* par_gen_html.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
#include <stdio.h>
#include <string.h>
#include "par.h"
#include "dan_act.h"
/* ----------------------------------------------------------- */
static void tbl_row (PAR *par, FILE * fd, NODE * node);
static void gen_table (PAR *par, FILE * fd);
/* ----------------------------------------------------------- */
int
par_gen_html (PAR *par)
{
  FILE *fd;

  char *pname;
  char filename[48];
  pname = par->pname;
  strcpy (filename, pname);
  strcat (filename, ".html");
  fd = fopen (filename, "w");
  gen_table (par, fd);
  fclose (fd);
}
/* ----------------------------------------------------------- */
static void
gen_table (PAR *par, FILE * fd)
{
  NODE *rule;
  NODE *node;

  fprintf (fd, "<html>\n");
  fprintf (fd, "<body>\n");
  fprintf (fd, "&nbsp;\n");
  fprintf (fd,
	   "<table BORDER WIDTH=\"50%\" bgcolor = \"white\" cellpadding=\"4\" ALIGN=center>\n");
  fprintf (fd, "<tr>\n");
  fprintf (fd, "<td> ID </td>\n");
  fprintf (fd, "<td> OPER </td>\n");
  fprintf (fd, "<td> NAME </td>\n");
  fprintf (fd, "<td> ACTION </td>\n");
  fprintf (fd, "<td> BT </td>\n");
  fprintf (fd, "<td> BF </td>\n");
  fprintf (fd, "</tr>\n");

  for (rule = (NODE *)par->top_rule; rule; rule = rule->rlink)
  for (node = rule; node;node = node->nlink) 
	{
	  if (node->type != 'X')
	    tbl_row (par, fd, node);
	}

  fprintf (fd, "</table>\n");
  fprintf (fd, "</body>\n");
  fprintf (fd, "</html>\n");
}

/* ----------------------------------------------------------- */
static void
tbl_row (PAR *par, FILE * fd, NODE * node)
{
/* BEGIN ROW */
  fprintf (fd, "<tr>\n");
  /* ID */
  fprintf (fd, "<td>%d</td>\n", node->id);
  /* TYPE */
  switch (node->type)
    {
    case 'N':
      fprintf (fd, "<td>net</td>\n");
      break;
    case 'D':
      fprintf (fd, "<td>rule</td>\n");
      break;
    case 'A':
      fprintf (fd, "<td>code</td>\n");
      break;
    case 'R':
      fprintf (fd, "<td>call</td>\n");
      break;
    case 'I':
      fprintf (fd, "<td>cmp</td>\n");
      break;
    case 'L':
      fprintf (fd, "<td>cmp</td>\n");
      break;
    }
  /* NAME */
  fprintf (fd, "<td NOWRAP>%s</td>\n", node->name);
  /* ACTION */
  if (node->action)
    fprintf (fd, "<td NOWRAP>%d</td>\n", node->ano);
  else
    fprintf (fd, "<td NOWRAP>--</td>\n");
  /* RIGHT */
  if (node->suc > (NODE *) 3)
    fprintf (fd, "<td NOWRAP>%d </td>\n", node->suc->id);
  else
    {
      switch ((int) (node->suc))
	{
	case 0:
	  fprintf (fd, "<td NOWRAP>rtn 0 </td>\n");
	  break;
	case 1:
	  fprintf (fd, "<td NOWRAP>rtn 1 </td>\n");
	  break;
	case 2:
	  fprintf (fd, "<td NOWRAP>err %d  </td>\n", node->eno);
	  break;
	}
    }
  /* LEFT */
  if (node->alt > (NODE *) 3)
    fprintf (fd, "<td NOWRAP>%d</td>\n", node->alt->id);
  else
    {
      switch ((int) (node->alt))
	{
	case 0:
	  fprintf (fd, "<td NOWRAP>rtn 0 </td>\n");
	  break;
	case 1:
	  fprintf (fd, "<td NOWRAP>rtn 1 </td>\n");
	  break;
	case 2:
	  fprintf (fd, "<td NOWRAP>err %d </td>\n", node->eno);
	  break;
	}
    }
  /* END ROW */
  fprintf (fd, "</tr>\n");
}

/* ----------------------------------------------------------- */
static void
gen_index (PAR *par)
{
  FILE *fd;
  NODE *rule;

  char *pname;
  char filename[48];
  pname = par->pname;;
  strcpy (filename, pname);
  strcat (filename, "indix.html");
  fd = fopen (filename, "w");

  fprintf (fd, "<html>\n");
  fprintf (fd, "<body>\n");
  fprintf (fd, "&nbsp;\n");
  fprintf (fd,
	   "<table BORDER WIDTH=\"25%\" bgcolor = \"white\" cellpadding=\"4\">\n");

  rule = (NODE *) par->top_rule;
  do
    if (rule->type == 'D')
      fprintf (fd, "<tr><a href = \"%s.html\"></a></tr>\n", rule->name);
  while (rule = rule->rlink);

  /* fprintf (fd, "</tr>\n"); */
  fprintf (fd, "</table>\n");
  fprintf (fd, "</body>\n");
  fprintf (fd, "</html>\n");
  fclose (fd);
}
