/* par_gen_oper.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
#include "par.h"
#include "dan_act.h"
#include "par_sym.h"
/* ----------------------------------------------------------- */
static const char *oper_err[] =
{
"\tfprintf (stderr, \"ERROR: line no. %d\\n\", par->lineno);",
"\tfprintf (stderr, \"PAR_LEX_OPER: Illegal operator.\\n\");",
"\tfprintf (stderr, \"PAR_LEX_OPER: [%d %c]\\n\",",
"\t\tpar->lex_c, par->lex_c);",
"\texit(1);"
 };

/* -------------- PROTOTYPES OF LOCAL PROCEDURES ----------------- */

/* -------------------------------------------------------------- */
void
par_gen_oper (PAR * par)
{
  FILE *fd;
  NODE *top;
  SYM *sym;
  

  int k;
  char *pname;

  if (par->gen_lexer)
    return;

  fd = fopen ("par_lex_operator.dan", "w");

  fprintf (fd, "# par_lex_operator.dan.\n");
  fprintf (fd, "# DANTE GENERATED OUTPUT\n");

  fprintf (fd, "{\n");
  fprintf (fd, "#include \"par.h\"\n");
  fprintf (fd, "}\n");

  fprintf (fd, "lex_operator: EOF {par_lex_accept(par); par->type = 0;}\n");

  k = 0;
  while (sym = (SYM *) Item (par->stk_literal, k++))
    {
      if (strlen (sym->name) == 2)
	{
	  fprintf (fd, "\t| '%c'  {par_lex_accept(par); par->type = %d;}\n ", 
	           sym->name[0], sym->name[0]);
	  fprintf (fd, "\t  ['%c'] {par_lex_accept(par); par->type = %d;}\n", 
	           sym->name[1], sym->type);
	}
    }

  k = 0;
  while (sym = (SYM *) Item (par->stk_literal, k++))
    {
      if (strlen (sym->name) == 1)
	{	 
	  fprintf (fd, "\t| '%c' {par_lex_accept(par); par->type = %d;}\n", 
	           sym->name[0], sym->type);
	}
    }

  fprintf (fd, "\t| error\n");
  fprintf (fd, "   ;\n");
  
  fprintf (fd, "error:\n");
  fprintf (fd, "{\n");
  fprintf (fd, "%s\n", oper_err[0]);
  fprintf (fd, "%s\n", oper_err[1]);
  fprintf (fd, "%s\n", oper_err[2]);
  fprintf (fd, "%s\n", oper_err[3]);
  fprintf (fd, "%s\n", oper_err[4]);
  fprintf (fd, "} ;\n");
  
  fprintf (fd, "dan_type_code EOF 0 ;\n");
  fprintf (fd, "dan_lex_fun ;\n");
 
  fclose (fd);
}
